using System;
using System.Runtime.InteropServices;

namespace reversepinvokefromthread
{
    class WrapperAPILib
    {

        public delegate void DlgSimpleCallback(System.Int32 i);

        [DllImport("reversepinvokefromthread.so")]
        static public extern void SetSimpleCallback(IntPtr cb);
        [DllImport("reversepinvokefromthread.so")]
        static public extern void StartTestThread();
    }

    class Program
    {
        static IntPtr p_fnSimpleCallback;
        static GCHandle gchSimpleCallback;

        static void fnSimpleCallback(System.Int32 i)
        {
            Console.WriteLine("Got here number: {0}", i);
        }

        static void Main(string[] args)
        {
            WrapperAPILib.DlgSimpleCallback del = new WrapperAPILib.DlgSimpleCallback(fnSimpleCallback);
            p_fnSimpleCallback = Marshal.GetFunctionPointerForDelegate<WrapperAPILib.DlgSimpleCallback>(del);
            gchSimpleCallback = GCHandle.Alloc(del);

            WrapperAPILib.SetSimpleCallback(p_fnSimpleCallback);

            WrapperAPILib.StartTestThread();

            Console.WriteLine("Sleeping in Main ...");
            System.Threading.Thread.Sleep( 6000);
            WrapperAPILib.StartTestThread();

            Console.ReadKey();
        }
    }
}
